/* $Id: db.c 12 2023-04-18 13:47:57Z nishi $ */
#include <swinehub/db.h>

#include <swinehub.h>

#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>

DBM* swinehub_token_db = NULL;
DBM* swinehub_user_db = NULL;

int swinehub_db_init(){
	if(swinehub_token_db != NULL){
		dbm_close(swinehub_token_db);
	}
	if(swinehub_user_db != NULL){
		dbm_close(swinehub_user_db);
	}
	swinehub_token_db = dbm_open(
		SWINEHUB_TOKEN_DB,
		O_RDWR | O_CREAT,
		S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH
	);
	swinehub_user_db = dbm_open(
		SWINEHUB_USER_DB,
		O_RDWR | O_CREAT,
		S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH
	);
	if(swinehub_token_db == NULL){
		printf("Status: 500 Internal Server Error\r\n\r\nDatabase Error (Token DB, %s): %s", SWINEHUB_TOKEN_DB, strerror(errno));
		return -1;
	}
	if(swinehub_user_db == NULL){
		printf("Status: 500 Internal Server Error\r\n\r\nDatabase Error (User DB, %s): %s", SWINEHUB_USER_DB, strerror(errno));
		return -1;
	}
	return 0;
}
