/* $Id: util.c 15 2023-04-20 10:18:37Z nishi $ */
#include <swinehub/util.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

extern char** environ;

char* sstrcat(const char* str1, const char* str2){
	char* str = malloc(strlen(str1) + strlen(str2) + 1);
	strcpy(str, str1);
	strcpy(str + strlen(str1), str2);
	str[strlen(str1) + strlen(str2)] = 0;
	return str;
}

char* sstrcat3(const char* str1, const char* str2, const char* str3){
	char* tmp = sstrcat(str1, str2);
	char* str = sstrcat(tmp, str3);
	free(tmp);
	return str;
}

char* sstrcat4(const char* str1, const char* str2, const char* str3, const char* str4){
	char* tmp = sstrcat3(str1, str2, str3);
	char* str = sstrcat(tmp, str4);
	free(tmp);
	return str;
}

char* sstrcat5(const char* str1, const char* str2, const char* str3, const char* str4, const char* str5){
	char* tmp = sstrcat4(str1, str2, str3, str4);
	char* str = sstrcat(tmp, str5);
	free(tmp);
	return str;

}

char* swinehub_get_request(){
	int i;
	char* tmp;
	char* request = malloc(1);
	request[0] = 0;
	for(i = 0; environ[i] != NULL; i++){
		char* name = strdup(environ[i]);
		int j;
		for(j = 0; environ[i][j] != 0 && environ[i][j] != '='; j++);
		char* original_name = strdup(name);
		name[j] = 0;
		if(strlen(name) > strlen("HTTP_")){
			name[strlen("HTTP_")] = 0;
			if(strcmp(name, "HTTP_") == 0){
				char* key = strdup(original_name + strlen("HTTP_"));
				char* value;
				for(j = 0; key[j] != 0 && key[j] != '='; j++);
				key[j] = 0;
				value = key + j + 1;
				for(j = 0; key[j] != 0; j++){
					if(key[j] == '_') key[j] = '-';
				}
				if(strcmp(key, "DAV") == 0){
					setenv("ISDAV", "YES", 1);
				}else if(strcmp(key, "AUTHORIZATION") == 0){
					setenv("ISAUTH", "YES", 1);
				}

				if(strcmp(key, "HOST") != 0){
					tmp = request;
					request = sstrcat(tmp, key);
					free(tmp);
					tmp = request;
					request = sstrcat(tmp, ": ");
					free(tmp);
					tmp = request;
					request = sstrcat(tmp, value);
					free(tmp);
					tmp = request;
					request = sstrcat(tmp, "\r\n");
					free(tmp);
				}
				free(key);
			}
		}
		free(name);
		free(original_name);
	}
	return request;
}
